package dicom;


import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Iterator;
import java.awt.Graphics2D;

import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;
import java.io.FileInputStream;

import org.dcm4che2.data.DicomElement;
import org.dcm4che2.data.DicomObject;
import org.dcm4che2.data.Tag;

import org.dcm4che2.io.DicomInputStream;
import org.dcm4che2.image.OverlayUtils;
import org.dcm4che2.imageio.plugins.dcm.DicomImageReadParam;
import org.dcm4che2.io.DicomInputStream;



/**
 * <Class>Dicom</Class> 
 * Solution de l'affichage d'une image
 * @author PIANETA
 *
 */
public class Dicom  {

	private static final long serialVersionUID = 1L;

  
	
	private int count = 0;
	private String fichierCourant;
	private int number ;
	private BufferedImage image = null;
	private DicomImageReadParam param1 =null;
        private String result = null;
        private Double result2 = null;
        private String nom = null;
	private String nounString = null;
        private int val2 = 0;
        private int valeurReturn;
        private String nounUnit = null;
        private static DicomObject object = null;
        private static double resultFacteurDix	= 0;
        private Double valueSpatial = null;
      	private String nounUnitRatio = null;
	/*met en variable tempon le chemin du fichier
	 * @return rien*/
	 public void setFichierCourant(String fichierCourant)
	    {
	        this.fichierCourant = fichierCourant;
	        
	    }
	 /**
	  * Permet de renvoyer la variable du fichier
	  * @return le string du chemin du fichier s�lectionner dicom
	  */
	 public String getFichierCourant(){
		 return fichierCourant;
	 }	

         /**
	 * Permet de verifier l'extension dicom
	 * @param file : fichier entrée
	 * @return boolean false si l'extension n'est pas un dicom
	 */
	public static boolean verifDicom(File file){
		  FiltreExtension filtre4 = new FiltreExtension("Fichiers DCM");
		    filtre4.addExtension(".dcm");
			filtre4.addExtension(".dic");
			filtre4.addExtension(".dicm");
			filtre4.addExtension(".dicom");
			return filtre4.accept(file);

	}

        	/**
	 * Dicom sans extension
	 * @param file : fichier entree
	 * @return un boolean en verifiant si le fichier et un dicom
	 */
	public static boolean verifDicomSansExt(File file){
		  FiltreExtension filtre3 = new FiltreExtension("All");
		  return filtre3.accept(file);
	}




	 /**
 * Méthode qui permet de récupérer nbOfFrame qui signifie le nombre de frame disponible dans un  fichier dicom(on peut dire le nombre d'image présent dans un fichier dicom)
 * @param file : variable qui prend le nom du fichier courant
 * @return un entier qui est ègale au nombredeFrame de l'image
 * @throws IOException
 */
   public int setNumber(File file) throws IOException  {

		    /* Parcourt le fichier dicom*/
	  	   Iterator<ImageReader> iter = ImageIO.getImageReadersByFormatName("DICOM");//spécifie l'image
	       ImageReader readers = (ImageReader)iter.next();//on se déplace dans l'image dicom

	        param1 =  (DicomImageReadParam) readers.getDefaultReadParam();//return DicomImageReadParam
	       //	Adjust the values of Rows and Columns in it and add a Pixel Data attribute with the byte array from the DataBuffer of the scaled Raster

	  	  ImageInputStream iis = ImageIO.createImageInputStream(file);//création du fichier image


	       readers.setInput(iis, false);//sets the input source to use the given ImageInputSteam or other  Object

	        //iis.close();
             number = readers.getNumImages(true);//numberOfFrame on a "readers" qui doit être DicomImage
	        System.out.println(number);//return NumberOfFrame (Tag : (0028, 0008))
	       return  number;
	    }
	    
	        /**
	         * M�thode qui renvoie le nombre de frame 
	         * @return number le nombre de frame pour une image dicom
	         */
	    public int getNumber(){
	    	return number;
	    }

	    
	    	/**
	    	 * Obtient le nombre courant du compteur
	    	 * @return count: le nombre courant du compteur
	    	 */
		 public int getCount(){
			    return count;
				
		    }
		  

		  /**
		   * 
		   * @param count: le nombre courant
		   * @return le nombre courant du compteur
		   */
		    public int setCount(final int count){
		    	return this.count = count;
		    }
		    
		


 /**
  * Compteur des boutons.
  * --> condition: on se rappel que la fonction read(int imageIndex, ImageReadParam param) avec imageIndex : de 0 à numberOfFrames-1
  * @param nom : permet de savoir quel est le bouton appuyer
  * @param n : est le nombre nbreOfFrame max --> le nombre de frame disponible dans un fichier dicom sélectionner
  * @return renvoie la valeur de 0 à nbreOfFrame-1
  * @throws IOException
  */
 		   public  int calcul(Boolean nom, int n) throws IOException{

 		    	/*compte de 1 à n-1*/
 				if(count<n-1 ){
 				if(nom==true){

 			    	count++;//incrémente ce qui signifie count = count+1
 					}
 		    	}

 				/*compte de  n à */
 				if(count>=1){
 				if(nom == false){

 			        count--;//décrémente ce qui signifie count = count-1
 				    }
 				}

 				return count;//décalage pour avoir 0 à nbreOfFrame-1
 		    }

 		  /**
		     * Affichage du bufferedImage de l'image
		     * @param file : fichier entrée
		     * @param value : les variables pour changer d'image
		     * @return un bufferedImage
		     * @throws IOException
		     */
	    public BufferedImage chargeImageDicomBufferise(File file, int value) throws IOException  {

		  	  Iterator<ImageReader> iter = ImageIO.getImageReadersByFormatName("DICOM");//spécifie l'image


		  	ImageReader readers = iter.next();//on se déplace dans l'image dicom

		    param1 =  (DicomImageReadParam) readers.getDefaultReadParam();//return DicomImageReadParam
		       //	Adjust the values of Rows and Columns in it and add a Pixel Data attribute with the byte array from the DataBuffer of the scaled Raster

		  	  ImageInputStream iis = ImageIO.createImageInputStream(file);

		     readers.setInput(iis, false);//sets the input source to use the given ImageInputSteam or other  Object

		  	 image = readers.read(value,param1);//BufferedImage image = reader.read(frameNumber, param); frameNumber = int qui est l'imageIndex
		  	  System.out.println(image);//affichage au terminal des caractères de l'image

		  	  readers.dispose();//Releases all of the native sreen resources used by this Window, its subcomponents, and all of its owned children
		  	return  image;

		    }

	    /**
	     * Obtient l'image
	     * @return image: BufferedImage
	     */
	      public BufferedImage getImage(){
	    	return  image;
	      }

   	/**
	 * RechercheDicomItem permet de ce déplacer dans le tag pour accéder à item
	 * @param file : fichier entrée
	 * @param TAG : valeur du tag selon dcm4che2
	 * @throws IOException
	 */
	  	public void rechercheDicomItem(File file, int TAG) throws IOException{
	  		/*vérification des extensions dicom*/
	  		
	  		DicomInputStream dis = new DicomInputStream(file);
	 		 object = dis.readDicomObject();//lit les métadatas du fichier dicom
	 		 object.remove(Tag.PixelData);//on enlève le pixelData

	 		 Iterator<DicomElement> iter = object.iterator();//déplacement dans les tags
	 		 valeurReturn = 0;//si il n'y pas d'item donc on renvoie 0 pour permettre d'effacer le label

	 		 while(iter.hasNext() ){

	 	    	   DicomElement element=  iter.next();//prochain élèment dicom
	 	    	   int tag = element.tag(); //déplacement dans le tag qui retourne un entier

	 			   String tagVR =  ((DicomObject) object).vrOf(tag).toString(); //retourne la valeur attribuer avec spécification

	 			   /*Lecture des métadatas dans items*/
	 			   if (tagVR.equals("SQ")){
	 		    	   if(element.hasItems() ){//si il n'y a un item donc boucle

	 		    		   affichageDicomItem(element.addDicomObject(element.getDicomObject()),TAG );

	 		    		   continue;//passe cette condition pour lire la fin des tags
	 		    	   }
	 		       }
	 		 }
	  		
	  	}

	/**
	 * Donne la valeur String à rechercher
	 * @param object
	 * @param TAG
	 */

	  	public void affichageDicomItem(DicomObject object, int TAG) throws IOException{
	  			   valeurReturn = 0;//valeur initiale pour savoir si il y a une valeur
		           Iterator<DicomElement> iter = object.iterator();
		           while(iter.hasNext() ){

			    	   DicomElement element=  iter.next();//prochain élèment dicom
			    	    int tag = element.tag(); //déplacement dans le tag qui retourne un entier

			    	      if(tag == TAG){//vérifie si il y a une valeur

			    	    	String result = object.getString(TAG);//affichage de la chaine de caractère du tag sélectionner
			    	    	setTagItem(result);//prend la valeur result pour permettre de savoir si le tag est vide ou pas

			    	    	double result2 = object.getDouble(TAG);
			    	    	setTagItemDouble( floor(result2, 5));//convertie le tag en arrondie

			    	    	setValeurReturn(1);//il y a une valeur dans le tag
			    	      }
	  	}
}
  	/**
	  	 * Donne la valeur du ratio spatial en mm/pixel
	  	 * @param file
	  	 * @throws IOException
	  	 */
		public void rechercheDicomRatioSpatial(File file, int TAG) throws IOException{
	  		/*vérification des extensions dicom*/
	  		if(verifDicom(file)||verifDicomSansExt(file) ){
	  		DicomInputStream dis = new DicomInputStream(file);
	 		 object = dis.readDicomObject();//lit les métadatas du fichier dicom
	 		 object.remove(Tag.PixelData);//on enlève le pixelData
	  	     
	 		 Iterator<DicomElement> iter = object.iterator();//deplacement dans les tags
	 		 valeurReturn = 0;//si il n'y pas d'item donc on renvoie 0 pour permettre d'effacer le label 
	 		  
	 		 while(iter.hasNext() ){//condition d'arret quand il n'y a plus item dans le fichier 
	 			 
	 	    	   DicomElement element=  iter.next();//prochain element dicom
	 	    	   int tag = element.tag(); //deplacement dans le tag qui retourne un entier
	 	    	    	    	   
	 			   String tagVR =  ((DicomObject) object).vrOf(tag).toString(); //retourne la valeur attribuer avec specification
	 						
	 			   /*Lecture des metadatas dans items*/
	 			   if (tagVR.equals("SQ")){
	 		    	   if(element.hasItems() ){//si il n'y a un item donc boucle 
	 		    		   
	 		    		   affichageDicomItemRatioSpatial(element.addDicomObject(element.getDicomObject()), Tag.PhysicalDeltaX );
	 		    		    		
	 		    		   continue;//passe cette condition pour lire la fin des tags
	 		    	   }
	 		       } 
	 		 }
	  		}else return;//rien faire
	  	}
	  	
	  	
	  	public void affichageDicomItemRatioSpatial(DicomObject object, int TAG) throws IOException{
			   valeurReturn = 0;//valeur initiale pour savoir si il y a une valeur
	           Iterator<DicomElement> iter = object.iterator();
	           while(iter.hasNext() ){
		    	   			    	   
		    	   DicomElement element=  iter.next();//prochain element dicom
		    	    int tag = element.tag(); //deplacement dans le tag qui retourne un entier
		    	   
		    	    if(TAG == Tag.PhysicalDeltaX|| TAG == Tag.PhysicalDeltaY){
		    	      if(tag == TAG){//verifie si le tag existe dans le fichier
		    	      	    	    	
		    	    	double result2 = object.getDouble(TAG);
		    	    	setTagItemDouble( floor(result2, 5));//convertie le tag en arrondie	
		    	        Double valueSpatial	= setFacteurPuissance(10,1)*getValeurTagItemDouble();//décalage en mm du nombre par la fonction puissance
		    	        setTagItemDoubleRatio(valueSpatial);//prend la valeur ratio en mm   	    	        	
		    	        	setValeurReturn(1);//il y a une valeur dans le tag
		    	        }
		    	           	      
		    	    	
		    	      }
		    	    }
	}	



	 	/**
	 	 * Arrondi d'un double avec n éléments après la virgule
	 	 * @param a la valeur à convertir
	 	 * @param n le nombre de décimales à conserver
	 	 * @return La valeur arrondi à n décimales
	 	 */
	  	public double floor(double a, int n){
	  		double p =Math.pow(10.0,n);
	  	return result2 = Math.floor((a*p)+0.5)/p;

	  	}

	  	/**
	  	 * Prend la valeur interne d'un tag Item
	  	 * @param result
	  	 * @return
	  	 */
	  	public String setTagItem(String result){

	  		return this.result = result;
	  	}

	  	/**
	  	 * Donne la valeur du tag rechercher
	  	 * @return le String de la valeur rechercher du tag dans un item
	  	 */
	 	public String getValeurTagItem(){
	  		return result;
	  	}

	  	/**
	  	 * Prend la valeur interne d'un tag Item
	  	 * @param result
	  	 * @return
	  	 */
	  	public Double setTagItemDouble(double result2){

		  		return this.result2 = result2;
		  	}

		/**
	  	 * Donne la valeur du tag rechercher
	  	 * @return le Double de la valeur rechercher du tag dans un item
	  	 */

	  	public Double getValeurTagItemDouble(){

	  		return result2;
	  	}


                	/**
	  	 * Prend la valeur d'un Ratio Spatial
	  	 * @param valueSpatial
	  	 * @return
	  	 */
	  	public Double setTagItemDoubleRatio(double valueSpatial){
	  		return this.valueSpatial = valueSpatial;
	  	}

	  	/**
	  	 * Donne la valeur du Ratio
	  	 * @return
	  	 */
	public Double getValeurTagItemDoubleRatio(){

	  		return valueSpatial;
	  	}

        	/**
	  	 * Donne les valeurs calculer des puissances
	  	 * @param result3
	  	 * @param facteur
	  	 * @return
	  	 * @return
	  	 */
	  	public static double setFacteurPuissance(double result3, double facteur){
	  	 	   return resultFacteurDix	= Math.pow(result3, facteur);
  		 	}

	  	/**
	  	 * Obtient la valeur de puissance
	  	 * @return
	  	 */
	  	public static double getFacteurPuissance(){
	  		return resultFacteurDix;
	  	}




	  	/**
	  	 * Donne la valeur qui permet de savoir si il y a une valeure dans le tag
	  	 * @return le chiffre
	  	 */
	  	public int  getValeurReturn(){
		  		return valeurReturn;
		  	}

	  	/**
	  	 * Prend la valeur pour savoir si il y a une valeur dans le tag
	  	 * @param valeurReturn : prend soit 0 ou 1 --> 0 pas d'unité et 1 il y a une valeur
	  	 * @return this.valeurReturn = valeurReturn;
	  	 */
	  	public int setValeurReturn(int valeurReturn  ){

	  		return this.valeurReturn = valeurReturn;
	  	}



	  	/**
		 * Donne la valeur String  d'une unité à rechercher pour un TAG Item
		 * @param file : fichier entrée
		 * @param TAG: valeur du tag
		 */
		public void rechercheDicomUnit(File file, int TAG) throws IOException{
			
			DicomInputStream dis = new DicomInputStream(file);
	 		 object = dis.readDicomObject();
	 		 object.remove(Tag.PixelData);//on enlève le pixelData

	 		 Iterator<DicomElement> iter = object.iterator();

	 		 while(iter.hasNext() ){

	 	    	   DicomElement element=  iter.next();//prochain élèment dicom
	 	    	    int tag = element.tag(); //déplacement dans le tag qui retourne un entier

	 	    	    /*Vérification terminal*/

	 			   String tagVR =  ((DicomObject) object).vrOf(tag).toString(); //retourne la valeur attribuer avec spécification


	 			   if (tagVR.equals("SQ")){
	 		    	   if(element.hasItems() ){//si il n'y a un item donc boucle

	 		    		  affichageDicomUnit(element.addDicomObject(element.getDicomObject()),TAG );

	 		    		   continue;//passe cette condition pour lire la fin des tags
	 		    	   }

	 		    	  String result = object.getString(TAG);
		    	     unit(TAG, result);


	 		       }
	 		 }
			
	  	}


	/**
	 * Rentre dans Item
	 *
	 * unit pour les TAG suivant:
	 * (0018,6012) Region Spatial Format
	 * (0018,6014) Region Data Type
	 * (0018,6024) Physical Units X Direction
	 * (0018,6026) Physical Units Y Direction
	 * (0018,604C) Pixel Component Physical Units
	 * (0018,604E) Pixel Component Data Type
	 *
	 *
	 * @param object : le nouveau object
	 * @param TAG
	 */
	  	public void affichageDicomUnit (DicomObject object, int TAG){

		           Iterator<DicomElement> iter = object.iterator();
		           while(iter.hasNext() ){

			    	   DicomElement element=  iter.next();//prochain élèment dicom
			    	    int tag = element.tag(); //déplacement dans le tag qui retourne un entier

			    	    if(tag == TAG){//vérifie si il y a une valeur

			    	    	/*recupère un string*/
			    	    	String result = object.getString(TAG);
			    	    	unit(TAG, result);

			    	    }
	  	}
}

	  	/**
	  	 * Les unités spécifiques selon les tags pour vr= SQ
	  	 * @param TAG : le tag choisi
	  	 * @param result
	  	 */

	  	public void unit(int TAG, String result){

	  		if (TAG == Tag.RegionSpatialFormat ){
	  			val2= Integer.valueOf(result).intValue();//convertie en int

	  			switch(val2)
	  			{
	  			case 5:
	  				setNounUnit("Graphics");
	  			break;
	  			case 4:
	  				setNounUnit("Wave form(physiological traces, doppler traces,...");
	  			break;
	  			case 3:
	  				setNounUnit("Spectral(CW or PW Doppler");
	  			break;
	  			case 2:
	  				this.setNounUnit("M-Mode(tissue or flow)");
	  			break;
	  			case 1:
	  				this.setNounUnit("2D(tissue or flow");
	  			break;
	  			case 0:
	  				setNounUnit("None or not applicable");
	  			break;

	  			default:
	  				break;
	  			}

	  		}else if (TAG == Tag.RegionDataType ){
	  			val2= Integer.valueOf(result).intValue();//convertie en int

	  			switch(val2)
	  			{
	  			case 12:
	  				setNounUnit("Orther Physiological(Amplitude vs. Time)");
	  			break;
	  			case 11:
	  				setNounUnit("d(area)/dt");
	  			break;
	  			case 10:
	  				setNounUnit("Area Trace");
	  			break;
	  			case 9:
	  				setNounUnit("d(Volume)/dt Trace");
	  			break;
	  			case 8:
	  				setNounUnit("Volume Trace");
	  			break;
	  			case 7:
	  				setNounUnit("Doppler Max Trace");
	  			break;
	  			case 6:
	  				this.setNounUnit("Doppler Mode Trace");
	  			break;
	  			case 5:
	  				this.setNounUnit("Doppler Mean Trace");
	  			break;
	  			case 4:
	  				setNounUnit("CW Spectral Doppler");
	  			break;
	  			case 3:
	  				this.setNounUnit("PW Spectral Doppler");
	  			break;
	  			case 2:
	  				this.setNounUnit("Color Flow");
	  			break;
	  			case 1:
	  				this.setNounUnit("Tissue");
	  			break;
	  			case 0:
	  				this.setNounUnit("None or not applicable");
	  			break;
	  			default:
	  				break;
	  			}

	  			if(result =="A"){
	  				this.setNounUnit("ECG Trace");
	  			}else if(result =="B"){
	  				this.setNounUnit("Pulse Trace");
	  			}else if(result =="C"){
	  				this.setNounUnit("Phonocardiogram Trace");
	  			}else if(result =="D"){
	  				this.setNounUnit("Gray bar");
	  			}else if(result =="E"){
	 	  			this.setNounUnit("Color bar");
	  			}else if(result =="F"){
	 	  				this.setNounUnit("Integrated Backscatter");
	  			}else return;

	  			}else
	  				if (TAG == Tag.PhysicalUnitsXDirection || TAG == Tag.PhysicalUnitsXDirection || TAG == Tag.PixelComponentPhysicalUnits){
	  			val2= Integer.valueOf(result).intValue();//convertie en int

	  			switch(val2)
	  			{
	  			case 9:
	  				setNounUnit("cm*cm.pixel/sec");
	  			break;
	  			case 8:
	  				setNounUnit("cm*cm/pixel");
	  			break;
	  			case 7:
	  				setNounUnit("cm*pixel/sec");
	  			break;
	  			case 6:
	  				this.setNounUnit("dB*pixel/seconds");
	  			break;
	  			case 5:
	  				this.setNounUnit("hertz/pixel");
	  			break;
	  			case 4:
	  				setNounUnit("seconds/pixel");
	  			break;
	  			case 3:
	  				this.setNounUnit("cm/pixel");
	  			break;
	  			case 2:
	  				this.setNounUnit("dB/pixel");
	  			break;
	  			case 1:
	  				this.setNounUnit("percent/pixel");
	  			break;
	  			case 0:
	  				this.setNounUnit("None or not applicable");
	  			break;
	  			default:
	  				break;
	  			}

	  			if(result =="A"){
	  				this.setNounUnit("cm*cm*cm/pixel");
	  			}else if(result =="B"){
	  				this.setNounUnit("cm*cm*cm*pixel/sec");
	  			} if (result == "C"){
	  				this.setNounUnit("degrees");
	  			}

	  		}else if (TAG == Tag.PixelComponentDataType  ){
	  			val2= Integer.valueOf(result).intValue();//convertie en int

	  			switch(val2)
	  			{
	  			case 9:
	  				setNounUnit("Computed Border");
	  			break;
	  			case 8:
	  				setNounUnit("Integrated Backscatter");
	  			break;
	  			case 7:
	  				setNounUnit("Color bar");
	  			break;
	  			case 6:
	  				this.setNounUnit("Gray bar");
	  			break;
	  			case 5:
	  				this.setNounUnit("Color Flow Intensity");
	  			break;
	  			case 4:
	  				setNounUnit("Color Flow Variance");
	  			break;
	  			case 3:
	  				this.setNounUnit("Color Flow Velocity");
	  			break;
	  			case 2:
	  				this.setNounUnit("Spectral doppler");
	  			break;
	  			case 1:
	  				this.setNounUnit("Tissue");
	  			break;
	  			case 0:
	  				this.setNounUnit("None or not applicable");
	  			break;
	  			default:
	  				break;
	  			}

	  			if(result =="A"){
	  				this.setNounUnit("Tissue Classification");
	  			 }
	  		}
	  		else this.setNounUnit("None or not applicable");


	   	}

	  	/**
	  	 * Enregistre l'unité des items
	  	 * @param nounUnit
	  	 * @return this.nounUnit = nounUnit
	  	 */
	  	public String setNounUnit(String nounUnit){
	  		return this.nounUnit = nounUnit;

	  	}

	  	/**
	  	 * On obtient l'unité des items.
	  	 * @return le nom de l'unité
	  	 */
	  	public String getNounUnit(){
	  		return nounUnit;
	  	}
	      
	      	
	  	/**
		 * Donne la valeur String  d'une unite à rechercher pour un TAG Item
		 * @param file : fichier entree
		 * @param TAG: valeur du tag
		 */
		public void rechercheDicomUnitRatioSpatial(File file, int TAG) throws IOException{
			if(verifDicom(file)||verifDicomSansExt(file) ){
			DicomInputStream dis = new DicomInputStream(file);
	 		 object = dis.readDicomObject();
	 		 object.remove(Tag.PixelData);//on enlève le pixelData
	  	     
	 		 Iterator<DicomElement> iter = object.iterator();
	 		 
	 		 while(iter.hasNext() ){
	 	    	  	 	    	   
	 	    	   DicomElement element=  iter.next();//prochain element dicom
	 	    	    int tag = element.tag(); //deplacement dans le tag qui retourne un entier
	 	    	   
	 	    	    /*Verification terminal*/
	 	    	   
	 			   String tagVR =  ((DicomObject) object).vrOf(tag).toString(); //retourne la valeur attribuer avec specification		   
				   
	 			   if (tagVR.equals("SQ")){
	 		    	   if(element.hasItems() ){//si il n'y a un item donc boucle 
	 		    		   
	 		    		  affichageDicomUnitRatioSpatial(element.addDicomObject(element.getDicomObject()),TAG );
	 		    		    		
	 		    		   continue;//passe cette condition pour lire la fin des tags
	 		    	   }
	 		    	   
	 		    	  String resultSpatial= object.getString(TAG);
	 		    	  unitRatioSpatial(TAG, resultSpatial);   	    	
	 		    	   	 		    	   
	 		       }	   
	 		 }
			}else return;
	  	}
	  	
		/**
		 * Affichage de l'item pour le ratio Spatial(unite)
		 * @param object
		 * @param TAG
		 */
		public void affichageDicomUnitRatioSpatial (DicomObject object, int TAG){
	  		
	           Iterator<DicomElement> iter = object.iterator();
	           while(iter.hasNext() ){
		    	   			    	   
		    	   DicomElement element=  iter.next();//prochain element dicom
		    	    int tag = element.tag(); //deplacement dans le tag qui retourne un entier
		    	   
		    	    if(tag == TAG){//verifie si il y a une valeur 
		    	    
		    	    	/*recupere un string*/
		    	    	String resultSpatial = object.getString(TAG);
		    	    	unitRatioSpatial(TAG, resultSpatial);    
		    	    			    	    	
		    	    }	  	  
	     }	
}
	  	  	
	  	
	  	/**
	  	 * Special Ratio Spatial toutes les unites sont en mm
	  	 * @param TAG : entree choisi
	  	 * @param result: prend l'unite 
	  	 */
	  	public void unitRatioSpatial(int TAG, String result){
			if (TAG == Tag.PhysicalUnitsXDirection || TAG == Tag.PhysicalUnitsYDirection || TAG == Tag.PixelComponentPhysicalUnits){
	  			val2= Integer.valueOf(result).intValue();//convertie en int 
	  			
	  			switch(val2)
	  			{
	  			case 9:
	  				Double valueSpatial1 = getValeurTagItemDoubleRatio()* setFacteurPuissance(10,1);
	  			  	setTagItemDoubleRatio(valueSpatial1);//prend la valeur
	  				setNounUnitRatio("mm*mm.pixel/sec");
	  			break;
	  			case 8:
	  				Double valueSpatial2 = getValeurTagItemDoubleRatio()* setFacteurPuissance(10,1);
		    	    setTagItemDoubleRatio(valueSpatial2);//prend la valeur
	  				setNounUnitRatio("mm*mm/pixel");
	  			break;
	  			case 7:
	  				setNounUnitRatio("mm*pixel/sec");
	  			break;
	  			case 6:
	  				this.setNounUnitRatio("dB*pixel/seconds");
	  			break;
	  			case 5:
	  				this.setNounUnitRatio("hertz/pixel");
	  			break;
	  			case 4:
	  				setNounUnitRatio("seconds/pixel");
	  			break; 	
	  			case 3:
	  				this.setNounUnitRatio("mm/pixel");
	  			break;	
	  			case 2:
	  				this.setNounUnitRatio("dB/pixel");
	  			break;
	  			case 1:
	  				this.setNounUnitRatio("percent/pixel");
	  			break;
	  			case 0:
	  				this.setNounUnitRatio("None or not applicable");
	  			break;
	  			default:
	  				break;
	  			}
	  			
	  			if(result =="A"){
	  				Double valueSpatial3 = getValeurTagItemDoubleRatio()* setFacteurPuissance(10,2);
		    	    setTagItemDoubleRatio(valueSpatial3);//prend la valeur
	  				this.setNounUnitRatio("mm*mm*mm/pixel");
	  			}else if(result =="B"){
	  				Double valueSpatial4 = getValeurTagItemDoubleRatio()* setFacteurPuissance(10,2);
		    	    setTagItemDoubleRatio(valueSpatial4);//prend la valeur
	  				this.setNounUnit("mm*mm*mm*pixel/sec");
	  			} if (result == "C"){
	  				this.setNounUnit("degrees");
	  			}
			}  		
	  	}
/**
	  	 * Enregistre l'unite des items
	  	 * @param nounUnit
	  	 * @return this.nounUnit = nounUnit
	  	 */
	  	public String setNounUnitRatio(String nounUnitRatio){
	  		return this.nounUnitRatio = nounUnitRatio;

	  	}

	  	/**
	  	 * On obtient l'unite des items.
	  	 * @return le nom de l'unité
	  	 */
	  	public String getNounUnitRatio(){
	  		return nounUnitRatio;
	  	}

/**
 * BufferedImage overlayDicom
 * @param file: input file
 * @return bufferedImage overlay
 * @throws FileNotFoundException
 * @throws IOException
 */
public static BufferedImage overlayDicom (File file) throws FileNotFoundException, IOException{
    FileInputStream fis = new FileInputStream(file);
    DicomInputStream dis = new DicomInputStream(fis);
    DicomObject obj = dis.readDicomObject();
    Iterator<ImageReader> iter = ImageIO.getImageReadersByFormatName("DICOM");//spécifie l'image
    ImageReader readers = iter.next();
    if(obj.contains(Tag.OverlayData)==true ){
    BufferedImage buf = OverlayUtils.extractOverlay(obj,Tag.OverlayData , readers,null);
    return buf;

} else {
      return null;
       }

  
}


/**
 * Compined two bufferedImages
 * @param image1
 * @param image2
 * @return
 */
public static BufferedImage addImage(BufferedImage image1, BufferedImage image2){
	Graphics2D g2d = image1.createGraphics();
	g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
	RenderingHints.VALUE_ANTIALIAS_ON);
	g2d.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION,
	RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
	g2d.drawImage(image2, 0, 0, null);
	g2d.dispose();
	return image1 ;
	}





}
