/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dicom;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import org.dcm4che2.data.DicomObject;
import org.dcm4che2.io.DicomInputStream;
import org.dcm4che2.io.DicomOutputStream;

/**
 *
 * @author Dimitri
 */
public class RemoveTagPrivate {
    
     public static final String[] INCIDENT_TAGS = {
    		"0009,0010", "0009,1001" 
     
     
        };
    
    
      RemoveTagPrivate(File file, File output) {
        
        DicomObject dObj = readDicomObject(file);
                
        removeTag(dObj);
                  
          writeDicomFile(dObj, output);
        
        
       
    }
     
 
     
     
     
       /**
	 * Converts the string representation of a header number
	 * e.g. 0008,0010 to the corresponding integer as 0x00080010
	 * as used in the @see org.dcm4che2.data.Tag
	 * @param headerNr e.g. 0008,0010
	 * @return 0x00080010 as int
	 * @throws DicomHeaderParseException
	 */
	public static int toTagInt(String headerNr){
		return Integer.parseInt(headerNr.replaceAll(",", ""), 16);
                
                
	}
        
        
        
     
     
        
         public static DicomObject removeTag(DicomObject dObj) {

	    for (String tag : INCIDENT_TAGS ) {
                
		dObj.remove(toTagInt(tag));
	    }

	    return dObj;
	}
        
        
         /**
	 * Read the file into a dicom object
	 * @param f the dicom file
	 * @return the read dicom object
	 */
	public static DicomObject readDicomObject(File f) {
	    DicomObject dcmObj;
	    DicomInputStream din = null;
	    try {
	        din = new DicomInputStream(f);
	        dcmObj = din.readDicomObject();
	        return dcmObj;
	    }
	    catch (IOException e) {
		e.printStackTrace();
	        return null;
	    }
	    finally {
	        try {
	            din.close();
	        }
	        catch (IOException ignore) {
	        }
	    }
	}
        
        /**
	 * write the dicom object to a file
	 * @param dObj the object to write
	 * @param f the file to write to
	 */
	public static void writeDicomFile(DicomObject dObj, File f) {
	    FileOutputStream fos;
	    try {
	        fos = new FileOutputStream(f);
	    }
	    catch (FileNotFoundException e) {
	        e.printStackTrace();
	        return;
	    }
	    BufferedOutputStream bos = new BufferedOutputStream(fos);
	    DicomOutputStream dos = new DicomOutputStream(bos);
	    try {
	        dos.writeDicomFile(dObj);
	    }
	    catch (IOException e) {
	        e.printStackTrace();
	        return;
	    }
	    finally {
	        try {
	            dos.close();
	        }
	        catch (IOException ignore) {
	        }
	    }
	}

  
        
    
    
   

    
}
