package dicom;

import java.io.File;
import java.io.IOException;
import java.net.URL;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import org.dcm4che2.data.BasicDicomObject;
import org.dcm4che2.io.DicomInputStream;
import org.dcm4che2.io.SAXWriter;

/**
 * 
 * D'apr�s l'open source dcm4che
 * @author Dimitri
 *
 */
public class dcmXml {	
	
	 	private URL xslt;
	    private String[] xsltParams;
	    private File baseDir;
	    private int[] exclude;
	    private boolean xsltInc = false;
	    private boolean indent = true;
	    private boolean comments = false;

	    public final void setBaseDir(File baseDir) {
	        this.baseDir = baseDir;
	    }

	    public final void setExclude(int[] exclude) {
	        this.exclude = exclude;
	    }

	    public final void setIndent(boolean indent) {
	        this.indent = indent;
	    }

	    public final void setComments(boolean comments) {
	        this.comments = comments;
	    }
	    
	    public final void setXslt(URL xslt) {
	        this.xslt = xslt;
	    }

	    public final void setXsltInc(boolean xsltInc) {
	        this.xsltInc = xsltInc;
	    }

	    public final void setXsltParams(String[] xsltParam) {
	        xsltParams = (xsltParam != null ? xsltParam.clone() : null);
	    }
	/**
	 * Permet de faire le changement des metadonnees de dicom vers un format XML
	 * @param ifile
	 * @param ofile
	 * @throws IOException
	 * @throws TransformerConfigurationException
	 */
	 public void convert(File ifile, File ofile) throws IOException, TransformerConfigurationException {
 DicomInputStream dis = new DicomInputStream(ifile);
 try {
     TransformerHandler th = getTransformerHandler();
     th.getTransformer().setOutputProperty(OutputKeys.INDENT,indent ? "yes" : "no");
     th.setResult(ofile != null ? new StreamResult(ofile): new StreamResult(System.out));
     final SAXWriter writer = new SAXWriter(th, comments ? th : null);
     writer.setBaseDir(baseDir);
     writer.setExclude(exclude);
     dis.setHandler(writer);
     dis.readDicomObject(new BasicDicomObject(), -1);//lecture des metadonnees dicom
 } finally {
     dis.close();
 }
}
	 
	 /**
	  * G�re les m�tadonn�es de dicom
	  * @return
	  * @throws TransformerConfigurationException
	  * @throws IOException
  **/
          
         
  private TransformerHandler getTransformerHandler()
            throws TransformerConfigurationException, IOException {
        SAXTransformerFactory tf = (SAXTransformerFactory)
                TransformerFactory.newInstance();
        if (xsltFile == null)
            return tf.newTransformerHandler();

        TransformerHandler th = tf.newTransformerHandler(
                new StreamSource(xsltFile));
        return th;
    }
    
	 
	 
}
