    package dicom;

import dicom.data2;
import java.awt.image.Raster;
import java.io.BufferedOutputStream;
import java.util.Arrays;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.lang.String;
import java.sql.Time;
import java.util.Date;
import java.util.Iterator;
import java.util.logging.Logger;
import org.dcm4che2.data.BasicDicomObject;
import org.dcm4che2.data.DicomElement;
import org.dcm4che2.data.DicomObject;
import org.dcm4che2.data.ElementDictionary;
import org.dcm4che2.data.Tag;
import org.dcm4che2.data.VR;
import org.dcm4che2.io.DicomInputStream;
import org.dcm4che2.io.DicomOutputStream;
import org.dcm4che2.io.StopTagInputHandler;
import org.dcm4che2.net.Association;
import org.dcm4che2.net.CommandUtils;
import org.dcm4che2.net.DicomServiceException;
import org.dcm4che2.util.StringUtils;
import org.dcm4che2.util.ByteUtils;



/**
 *To permit of read Tag in a dicom and display frame
 * @author dimitri.pianeta@gmail.com
 * @version september 2010 and may 2011
 */
public class displayTag {

private DicomObject object = null;
private String result = null;
private static double result2 = 0;
private DicomObject dicomObj;// the dicomObject containing the Header
private static Logger logger = Logger.getLogger("dimitri.pianeta");
private static ElementDictionary dict = ElementDictionary.getDictionary();
private static String noun = null,nameTag=null;
private static Double noun2 = null;
private static Double resultFactorDix = null;

	/**
         * Put DicomObject
	 * @param dicomObject the dicomObject to set
	 */
	public void setDicomObject(DicomObject dicomObject) {
	    this.dicomObj = dicomObject;
	}

        /**
         * Giving dicomObject
	 * @return the dicomObject
	 */
	public DicomObject getDicomObject() {
	    return dicomObj;
	}


         /**
	 * Read the file into a dicom object
	 * @param f the dicom file
	 * @return the read dicom object
	 */
	public static DicomObject readDicomObject(File f) {
	    DicomObject dcmObj;
	    DicomInputStream din = null;
	    try {
	        din = new DicomInputStream(f);
	        dcmObj = din.readDicomObject();
	        return dcmObj;
	    }
	    catch (IOException e) {
		e.printStackTrace();
	        return null;
	    }
	    finally {
	        try {
	            din.close();
	        }
	        catch (IOException ignore) {
	        }
	    }
	}


  /**
	 * Affiche les donnees lu pour un tag choisi /Display Tag
	 * Sauf pour les parametres qui utilise vr=SQ/ not VR = SQ 
	 * @param file : donne le nom d'un fichier/Giving noun file 
	 * @param tag : int tag, le tag que nous voulons afficher
	 * @return String : donne la valeur du tag choisi
	 * @throws IOException
	 */

	public String affichageTagDonnee(File file,int tag) throws IOException{
	 DicomInputStream dis = new DicomInputStream(file);
	 object = dis.readDicomObject();//lit le fichier

       if(object.contains(tag)==true ){
         if (object.vm(tag)!=1 ){
         String tagValue2[] = ((DicomObject) object).getStrings(tag);//Conversion table in List to String
         String tagValue =displayTag.arrayToString(tagValue2,"\\");
         return this.setNameTag(tagValue);
            }else{
             String nameTag=object.getString(tag);
            return this.setNameTag(nameTag);
            }
        
        }
       else
return this.setNameTag(null);
        }
        /**
	 * Met le nom/Put noun 
	 * @param nameTag prend un tag selon le package DCM4CHE2
	 * @return String nameTag
	 */
	public String setNameTag(String nameTag) {
		this.nameTag = nameTag;
		return nameTag;
	}
        /**
	 * Choosing dicomObjet Item VR= SQ
	 * @param file : file inout
	 * @param TAG : new tag
	 * @throws IOException
	 */
	  	public static DicomObject chooserTagDicom(File file ) throws IOException{

	  		DicomInputStream dis = new DicomInputStream(file);
	 		DicomObject object = dis.readDicomObject();//read metadata
	 		 object.remove(Tag.PixelData);

	 		 Iterator<DicomElement> iter = object.iterator();//next pixel

	 		 while(iter.hasNext() ){

	 	    	   DicomElement element=  iter.next();//next elementData
	 	    	   int tag = element.tag();

	 			   String tagVR =  ((DicomObject) object).vrOf(tag).toString();

	 			   /*Read tag items*/
	 			   if (tagVR.equals("SQ")|element.hasDicomObjects()){
	 		    	   if(element.hasItems() ){//if item in metadata
	 		    		   element.addDicomObject(element.getDicomObject());
	 		    		   continue;
	 		    	   }
	 		       }
	 		 }
			return object;
	  	}

        /**
	 * Permit read tag  value parameter VR=SQ
	 * Example:
         *   DicomObject object= displayTag.chooserTagDicom( fileInput);
         *  DicomObject object3 = displayTag.getObjectItem(object,Tag.RequestAttributesSequence);
                  System.out.println("Test 3"+object3.getString(Tag.RequestedProcedureID ));
	 * getObjectItem(object,Tag.ReferencedSOPSequence)
	 *
	 * @param object :DicomObject
	 * @param Tag : Tag of VR=SQ
	 * @return DicomObject
	 */
	public static DicomObject getObjectItem(DicomObject object,int Tag){
			DicomElement cmtSequence = object.get(Tag);
			DicomObject   dcm =null;
			if (cmtSequence.hasDicomObjects() ){
				for(int i=1;i<cmtSequence.countItems();i++)
				   dcm = cmtSequence.getDicomObject(i);
				return dcm;
			}else{
				return object;
			}
	}

/**
 * Permit read header in stopTag 
 * @param dicomFile : file input
 * @param stopTag : tag stop in metadata
 * @return DicomObject
 * @throws IOException
 */
    public static DicomObject getDicomObject(File dicomFile, int stopTag) throws IOException {

    DicomInputStream dis = new DicomInputStream(dicomFile);
    dis.setHandler(new StopTagInputHandler(stopTag));
    DicomObject obj = dis.readDicomObject();
    dis.close();
    return obj;

}




	/**
	 * Taking tag of item no use Tag with VR = SQ (no Tag.RequestAttributesSequence)
         *   Begining code
	 * @param file : fichier entree
	 * @param TAG : valeur du tag selon dcm4che2 voir la javadoc dcm4che
	 * @throws IOException
         * @see : DicomObject object= conv.chooserTagDicom( fileInput); DicomObject object3 = conv.getObjectItem(object,Tag.RequestAttributesSequence);
	 */
	  	public void findTagDicomItem(File file, int TAG) throws IOException{

	  		DicomInputStream dis = new DicomInputStream(file);//Input dicom
	 		 object = dis.readDicomObject();//read metadata
	 		 object.remove(Tag.PixelData);//remove Pixel data (read)
                         
	 		 Iterator<DicomElement> iter = object.iterator();

	 		 while(iter.hasNext() ){//Stop Item

	 	    	   DicomElement element=  iter.next();//Following item
	 	    	   int tag = element.tag(); //new Tag of metadata

	 			   String tagVR =  ((DicomObject) object).vrOf(tag).toString(); //Giving Value Representation of metadata dicom

	 			   /*Read Item*/
	 			   if (tagVR.equals("SQ")|element.hasDicomObjects()){
	 		    	   if(element.hasItems() ){//If he has tag Item in metadata
	 		    		   DicomItem(element.addDicomObject(element.getDicomObject()),TAG );
	 		    		   continue;//continue loop
	 		    	   }
	 		       }
	 		 }
	  	}

public void DicomItem(DicomObject object, int TAG) throws IOException{

		           Iterator<DicomElement> iter = object.iterator();
		           while(iter.hasNext() ){

			    	   DicomElement element=  iter.next();
			    	    int tag = element.tag(); 

			    	      if(tag == TAG && tag != 0&& tag != 0 && object.contains(tag)){// if tag chooser is find
                                            String vrName =  ((DicomObject) object).vrOf(tag).toString();

                                                    if(vrName.equalsIgnoreCase("DA")||vrName.equalsIgnoreCase("DT") ){
                                                         getHeaderDateValue(tag,object) ;
                                                         
                                                      } else if (vrName.equalsIgnoreCase("TM")){
                                                          
                                                      }
	
			    	      }
	  	}
}

/**
 * Chooser Dicom Item VR= SQ
 * Example :
 * 
 * @param file : input file
 * @param TAG : chooser Tag
 * @throws IOException
 */
public void chooserDicomItem(File file, int TAG) throws IOException{
	  		DicomInputStream dis = new DicomInputStream(file);
	 		 object = dis.readDicomObject();
	 		 object.remove(Tag.PixelData);

	 		 Iterator<DicomElement> iter = object.iterator();

	 		 while(iter.hasNext() ){
	 	    	   DicomElement element=  iter.next();
	 	    	   int tag = element.tag(); 

	 			   String tagVR =  ((DicomObject) object).vrOf(tag).toString(); 
	 			   
	 			   if (tagVR.equals("SQ")|element.hasDicomObjects()){
	 		    	   if(element.hasItems() ){//si il n'y a un item donc boucle
	 		    		   affichageDicomItem(element.addDicomObject(element.getDicomObject()),TAG );
	 		    		   continue;
	 		    	   }
	 		       }
	 		 }
	  	}


	  	public void affichageDicomItem(DicomObject object, int TAG) throws IOException{
	  			
		           Iterator<DicomElement> iter = object.iterator();
		           while(iter.hasNext() ){

			    	     DicomElement element=  iter.next();
			    	     int tag = element.tag(); 

			    	      if(tag == TAG){
			    	    	result = object.getString(TAG);
			    	    	setTagItem(result);
                                        
			    	    	 result2 = object.getDouble(TAG);
			    	    	 setTagItemDouble(result2);
			    	      }
	  	}
}

/**
 * Putting setTagItem function chooserDicomItem(File file, int TAG)
 * @param noun
 */
 public void setTagItem(String noun){
     this.noun =noun;
 }

 /**
  * Giving getTagItem function choosrDicomItem(File file, int TAG)
  * @return
  */
 public  String getTagItem(){
     return noun;
 }

 /**
  * Putting setTagItemDouble(Double noun2) function choosrDicomItem(File file, int TAG)
  * @param noun2
  */
 public  void setTagItemDouble(Double noun2){
     displayTag.noun2 = noun2;
 }

 /**
  *  Giving getTagItemDouble() function choosrDicomItem(File file, int TAG)
  * @return
  */
 public Double getTagItemDouble(){
     return noun2;
 }


 
 

  //Methods use tag

                        

 /**
 * Permet d'afficher l'heure d'une valeur dicom en standard international yyyy.mm.dd
 * @param file : fichier en entrée
 * @param Tag : valeur du tag
 * @param valueBool : si true Format yyyy.mm.dd sinon format dd.mm.yyyy
 * @param valueNoun :  "dot" mettre la date en format yyyy.mm.dd ou dd.mm.yyyy sinon en format yyyy mm dd ou dd mm yyyy
 * @return afficher le string du tag selon le standard international
 * @throws IOException
 */
public static String dicomDate(File file , int Tag,boolean valueBool, String valueNoun) throws IOException{
	DicomInputStream dis = new DicomInputStream(file);
	DicomObject object = dis.readDicomObject();
         if(object.contains(Tag)==true ){

	String tagValue = ((DicomObject) object).getString(Tag);
	String tagDayFomat = FormatDate(tagValue,valueBool,valueNoun);
return tagDayFomat;
         }else return null;
}

/**
 * Permet d'afficher l'heure d'une valeur dicom en standard international yyyy.mm.dd
 * @param object
 * @param Tag : valeur du tag
 * @param valueBool : si true Format yyyy.mm.dd sinon format dd.mm.yyyy
 * @param valueNoun :  "dot" mettre la date en format yyyy.mm.dd ou dd.mm.yyyy sinon en format yyyy mm dd ou dd mm yyyy
 * @return afficher le string du tag selon le standard international
 * @throws IOException
 */
public static String dicomDate(DicomObject object , int Tag,boolean valueBool, String valueNoun) throws IOException{
	 String tagValue = ((DicomObject) object).getString(Tag);
	 String tagDayFomat = FormatDate(tagValue,valueBool,valueNoun);
return tagDayFomat;
}

/**
 * Format tag
 * @param Numero : String date
 * @param valueBool : if true Format yyyy.mm.dd else format dd.mm.yyyy
 * @param valueNoun :  "dot" put  the date in format yyyy.mm.dd or dd.mm.yyyy else in format yyyy mm dd or dd mm yyyy
 * @return
 */
 public static String FormatDate(String Numero, boolean valueBool,String valueNoun) {

		if (Numero.matches("^[0-9]*$")) {//If la chaine de caractère est un nombre ou un chiffre
			StringBuffer r = new StringBuffer();

                        if (valueBool ==true){//Format yyyy.mm.dd
			for (int i = 0, j = Numero.length(); i < j; i++) {
				r.append(Numero.charAt(i));
				if ((i == 3)||(i == 5) ){
                                    if(valueNoun == null ? "dot" == null : valueNoun.equals("dot")){
                                 r.append('.');
                                }else{
                                        r.append(' ');
                                }
			}
		}
                        return r.toString();

                        }
                        else{

                        for (int i = 6, j =8; i<j; i++) {//jours
                            r.append(Numero.charAt(i));
                                   if(i ==7 ){
                            if(valueNoun == null ? "dot" == null : valueNoun.equals("dot")){
                                          r.append('.');

                                    }else{
                                        r.append(' ');
                                }
                                   }

                        }
                        for (int i = 4, j =6; i<j; i++) {

                                r.append(Numero.charAt(i));//The first char value of the sequence is at index zero, the next at index one, and so on, as for array indexing.

                           if(i ==5 ){
                            if(valueNoun == null ? "dot" == null : valueNoun.equals("dot")){
                                          r.append('.');

                                    }else{
                                        r.append(' ');
                                }
                                   }
                        }

                       for (int i = 0, j =4; i<j; i++) {

                                r.append(Numero.charAt(i));//The first char value of the sequence is at index zero, the next at index one, and so on, as for array indexing.
			}
			return r.toString();
                }
	}
                return Numero;
 }


 /**
  * Read value tag of VR = DA
  *
  * If use setDicomObject(readDicomObject(File f)), and getHeaderDateValue(getDicomObject())
  * @param tagNr "0000,0010"
  * @return
  */
	public Date getHeaderDateValue(String tagNr) {
	    return getHeaderDateValue(toTagInt(tagNr));
	}

 /**
  * Read value tag of VR = DA
  * 
  * @param tagNr see dcm4che2
  * @return
  */
	public Date getHeaderDateValue(int tagNr) {
	    return dicomObj.getDate(tagNr);

	}

        /**
         * Read value tag of VR = DA
         * @param tagNr
         * @param dicomObj
         * @return
         */
        public Date getHeaderDateValue(int tagNr,DicomObject dicomObj) {
	    return dicomObj.getDate(tagNr);
	}

        /**
         * Read value tag of VR = DA
         * @param tagNr :"0000,0010"
         * @param dicomObj
         * @return
         */
public Date getHeaderDateValue(String tagNr,DicomObject dicomObj) {
	    return getHeaderDateValue(toTagInt(tagNr), dicomObj);
	}


 /**
  * Remove string ^ in file dicom
  * @param num
  * @return
  */
 public static String texteDicom(String num) {

		num = num.replaceAll("\\^+", " ");

return num;
	}

  /**
  * Convertor tag to String
  * Using VM !=1
   * example result [25, 25]
  * @param Tag
  * @return
  */
 public static String getStringTag(DicomObject object, int Tag){
	 	String tagValue2[] = ((DicomObject) object).getStrings(Tag);//Conversion table in List to String
	 	String tagValue = Arrays.asList(tagValue2).toString();
return tagValue;
 }

 /**
  * Convertor tag to String
  * Using VM !=1
  *  example result 25/25
  * @param object
  * @param Tag
  * @return
  */
 public static String getStringTag2(DicomObject object, int Tag){
                 String tagValue2[] = ((DicomObject) object).getStrings(Tag);//Conversion table in List to String
                 String tagValue =displayTag.arrayToString(tagValue2,"\\");
 return tagValue;
 }
 
 /**
 * Permit display time in hh.mm.ss
 * (0008,0030) AT S Study Time
 * (0008,0031) AT S Series Time
 * (0008,0032) AT S Acquisition Time
 * (0008,0033) AT S Image Time
 * @param file : input file
 * @param Tag : giving tag
 * @return
 * @throws IOException
 */
public static String dicomTime(File file, int Tag) throws IOException{
	  DicomInputStream dis = new DicomInputStream(file);
	  DicomObject object = dis.readDicomObject();
           if(object.contains(Tag)==true ){
	  String tagValue = ((DicomObject) object).getString(Tag);
	  String tagValueNotDot = formatNotDot(tagValue);
	  String tagTimeFomat = FormatTime(tagValueNotDot);
	  return tagTimeFomat;
           } else return null;
}

/**
 * Permit display time in hh.mm.ss.fac
 * (0008,0030) AT S Study Time
 * (0008,0031) AT S Series Time
 * (0008,0032) AT S Acquisition Time
 * (0008,0033) AT S Image Time
 * @param file : input file
 * @param Tag : giving tag
 * @return
 * @throws IOException
 */
public static String dicomTimeTotal(File file, int Tag) throws IOException{
	  DicomInputStream dis = new DicomInputStream(file);
	  DicomObject object = dis.readDicomObject();
           if(object.contains(Tag)==true ){
	  String tagValue = ((DicomObject) object).getString(Tag);
	  String tagTimeFomat = FormatTimes(tagValue);
	  return tagTimeFomat;
           } else return null;
}



/**
 * Permit display time in hh.mm.ss
 * (0008,0030) AT S Study Time
 * (0008,0031) AT S Series Time
 * (0008,0032) AT S Acquisition Time
 * (0008,0033) AT S Image Time
 * @param object : Metadata
 * @param Tag : value dicom
 * @return new value String
 * @throws IOException
 */
public static String dicomTime2(DicomObject object, int Tag) throws IOException{
	  String tagValue = ((DicomObject) object).getString(Tag);
	  String tagValueNotDot = formatNotDot(tagValue);
	  System.out.println(FormatTime(tagValueNotDot));
	  String tagTimeFomat = FormatTime(tagValueNotDot);
	  return tagTimeFomat;
}
/**
 * Permit display time in hh.mm.ss.frac
 * (0008,0030) AT S Study Time
 * (0008,0031) AT S Series Time
 * (0008,0032) AT S Acquisition Time
 * (0008,0033) AT S Image Time
 * @param object : Metadata
 * @param Tag : value dicom
 * @return new value String
 * @throws IOException
 */
public static String dicomTime3(DicomObject object, int Tag) throws IOException{
	  String tagValue = ((DicomObject) object).getString(Tag);
	  
	  String tagTimeFomat = FormatTimes(tagValue);
	  return tagTimeFomat;
}



 /**
 * Removing comma in String
 * @param num
 * @return
 */
public static String formatNotDot(String num) {
	num = num.trim().replaceAll("[^0-9\\+]", "");
	if (num.matches("^0*$"))
		num = "";
	return num;
}

/**
 * Format 
 * hh.mm.ss
 * @param Numero
 * @return
 */
 public static String FormatTime(String Numero) {

	if (Numero.matches("^[0-9]*$")) {
		StringBuilder r = new StringBuilder();
		for (int i = 0, j = 6; i < j; i++) {
			r.append(Numero.charAt(i));
			if ((i % 2 == 1) && (i < (j - 1)))
				r.append(':');
		}
		return r.toString();
	}
	return Numero;
}

 /**
 * Format
 * hh.mm.ss.frac
 * @param Numero
 * @return
 */
 public static String FormatTimes(String Numero) {

	if (Numero.matches("^[0-9].*$")) {
		StringBuilder r = new StringBuilder();
		for (int i = 0,j=Numero.length();i<j; i++) {
			r.append(Numero.charAt(i));
			if ((i % 2 == 1)&(i<5))
				r.append(':');
		}
		return r.toString();
	}
	return Numero;
}


/**
 * Convert an array of strings to one string
 * Put the 'separator' string between each element
 * @param a
 * @param separator
 * @return
 */
public static String arrayToString(String[] a, String separator){
    StringBuffer result = new StringBuffer();
    if(a.length>0) {
        result.append(a[0]);
        for(int i=1;i<a.length;i++){
        result.append(separator);
        result.append(a[i]);
    }
  }
return result.toString();
}





public void setResult(String result) {
	this.result = result;
}

public String getResult() {
	return result;
}

public static void setResult2(double result2) {
	displayTag.result2 = result2;
}

public static double getResult2() {
	return result2;
}

/**
 * Giving tag eg; "0000,0100" to 0x00000100
 * @param noun
 * @return
 */
    public  int forN(String noun){
        return Tag.forName(noun);
    
}

    /**
	 * reads a double value from tag dicom (dcm4che2)
	 * @param tagNr the Tag to read
	 * @return the value as double
	 */
	public double getHeaderDoubleValue(int tagNr) {
		try {
			return dicomObj.getDouble(tagNr);
		} catch (UnsupportedOperationException e) {
			logger.warning("Tag is not of type double, trying to parse.....");
			return Double.parseDouble(getHeaderStringValue(tagNr));
		}
	}

	/**
	 *
	 * @param headerNr e.g. "0018,0050" to get Slice Thickness<br>
	 * or "0008,0102#0054,0220" to get the Coding Scheme Designator after View Code Sequence
	 * @return double
	 * @throws DicomHeaderParseException
	 */
	public double getHeaderDoubleValue(String tagNr) {
		return getHeaderDoubleValue(toTagInt(tagNr));
	}


            /**
	 * reads a float value from tag dicom (dcm4che2)
	 * @param tagNr the Tag to read
	 * @return the value as float
	 */
	public float getHeaderFloatValue(int tagNr) {
		try {
			return dicomObj.getFloat(tagNr);
		} catch (UnsupportedOperationException e) {
			logger.warning("Tag is not of type double, trying to parse.....");
			return Float.parseFloat(getHeaderStringValue(tagNr));
		}
	}

/**
	 *
	 * @param headerNr e.g. "0018,0050" to get Slice Thickness<br>
	 * or "0008,0102#0054,0220" to get the Coding Scheme Designator after View Code Sequence
	 * @return double
	 * @throws DicomHeaderParseException
	 */
	public double getHeaderFloatValue(String tagNr) {
		return getHeaderFloatValue(toTagInt(tagNr));
	}

	/**
	 * reads a int value from the Dicomheader
	 * @param tagNr the Tag to read
	 * @return the value as int
	 */
	public int getHeaderIntegerValue(int tagNr) {
	    return dicomObj.getInt(tagNr);
	}

	/**
	 *
	 * @param headerNr e.g. "0018,0050" to get Slice Thickness<br>
	 * or "0008,0102#0054,0220" to get the Coding Scheme Designator after View Code Sequence
	 * @return int
	 * @throws DicomHeaderParseException
	 */
	public int getHeaderIntegerValue(String tagNr) {
	    return getHeaderIntegerValue(toTagInt(tagNr));
	}

	/**
	 * reads a String value from tag dicom (dcm4che2)
	 * @param tagNr the Tag to read
	 * @return the value as String
         *  Returns the Specific Character Set defined by Attribute Specific Character Set (0008,0005)
         * of this or the root Data Set, if this is a Nested Data Set containing in a Sequence Eleme
	 */
	public String getHeaderStringValue(int tagNr) {
	    try {
		DicomElement elem = dicomObj.get(tagNr);
		String val = elem.getString(dicomObj.getSpecificCharacterSet(),false);
		if (val == null) val = "";
		return val;
	    } catch (Exception e) {
		return "";
	    }
	}
        /**
	 * reads a String value from tag dicom (dcm4che2)
	 * @param tagNr the Tag to read
	 * @return the value as String
         *  Returns the Specific Character Set defined by Attribute Specific Character Set (0008,0005)
         * of this or the root Data Set, if this is a Nested Data Set containing in a Sequence Eleme
	 */
	public String[] getHeaderStringValues(int tagNr) {
	    try {
		DicomElement elem = dicomObj.get(tagNr);
		String[] val = elem.getStrings(dicomObj.getSpecificCharacterSet(),false);
		return val;
	    } catch (Exception e) {
		return null;
	    }
	}

	/**
	 * reads a String value from the Dicomheader
	 * @param tagNr the Tag to read
	 * @param dcmelement
	 * @return the value as String
	 */
	public String getHeaderStringValue(DicomElement dcmelement) {
	    try {
		String val = dcmelement.getString(dicomObj.getSpecificCharacterSet(),false);
		if (val == null) val = "";
		return val;
	    } catch (Exception e) {
		return "";
	    }
	}

	/**
	 *reads the tag (group,element)
	 * @param headerNr e.g. "0018,0050" to get Slice Thickness<br>
	 * @return String
	 * @throws DicomHeaderParseException
	 */
	public String getHeaderStringValue(String headerNr) {
	    headerNr = headerNr.replaceAll("xx", "00").replaceAll("XX", "00");
	    return getHeaderStringValue(toTagInt(headerNr));
	}


        /**
         * Giving time a tag ("xxxx,")
         * @param tagNr
         * @return
         */
	public Time getHeaderTimeValue(String tagNr) {
	    return getHeaderTimeValue(toTagInt(tagNr));
	}

        /**
         * Giving time a tag
         * @param tagNr
         * @return time
         */
	public Time getHeaderTimeValue(int tagNr) {
	    String time = getHeaderStringValue(tagNr);
	    if (time.length() != 6)
		return null;

	    try {
		int hour = Integer.parseInt(time.substring(0,2));
		int min = Integer.parseInt(time.substring(2,4));
		int sec = Integer.parseInt(time.substring(4,6));
		return new Time(hour,min,sec);
	    } catch (Exception e) {
		logger.warning("error parsing time: " + time);
	    }
	    return null;
	}


	/**
	 * checks if the Header contains the given tag
	 * @param tagNr
	 * @return
	 * @throws DicomHeaderParseException
	 */
	public boolean containsHeaderTag(String tagNr) {
	    return containsHeaderTag(toTagInt(tagNr));
	}

	/**
	 * checks if the Header contains the given tag
	 * @param tagNr
	 * @return
	 */
	public boolean containsHeaderTag(int tagNr) {
	    return dicomObj.contains(tagNr);
	}


	/**
	 * retrieves a specific HeaderTag that is inside anotehr tag
	 * or "0008,0102, 0054,0220" to get the Coding Scheme Designator after View Code Sequence
	 * @return String
	 * 	 * @param tagHierarchy; e.g. {Tag.UID, Tag.SOPInstanceUID, Tag.CodeMeaning}
	 * @return
	 */
	public String getHeaderValueInsideTag(int[] tagHierarchy) {

		try {
			DicomObject obj = dicomObj;
			for (int i = 0; i < tagHierarchy.length-1; i++) {
				obj = obj.get(tagHierarchy[i]).getDicomObject();
			}
			DicomElement elem = obj.get(tagHierarchy[tagHierarchy.length-1]);

		    return elem.getString(dicomObj.getSpecificCharacterSet(),false);
		} catch (Exception e) {
			String tags = "";
			for (int i = 0; i < tagHierarchy.length; i++) {
				tags += toTagString(tagHierarchy[i]) + " ";
			}
		    logger.info("DICOM Tag: " + tags + " not found");
		    return "";
	    }
	}

	/**
	 * retrieves a specific HeaderTag that is inside anotehr tag
	 * or "0008,0102, 0054,0220" to get the Coding Scheme Designator after View Code Sequence
	 * @return String
	 * @param headerNr
	 * @param parentTagNr
	 * @return
	 * @throws DicomHeaderParseException
	 */
	public String getHeaderValueInsideTag(String[] tagHierarchy) {
		int[] tags = new int[tagHierarchy.length];

		for (int i = 0; i < tagHierarchy.length; i++) {
			tags[i] = toTagInt(tagHierarchy[i].replaceAll("xx", "00").replaceAll("XX", "00"));

		}

		return getHeaderValueInsideTag(tags);
	}

	/**
	 * returns the name of the given Tag
	 * @param tagNr
	 * @return
	 */
	public static String getHeaderName(int tagNr) {
//	    return ElementDictionary.getDictionary().nameOf(tagNr);
	    return dict.nameOf(tagNr);
	}

	/**
	 * returns the name of the given Header field
	 * @param tagNr
	 * @return the name of the Field e.g. Patients Name
	 */
	public static String getHeaderName(String tagNr) {
		try {
			return getHeaderName(toTagInt(tagNr));
		} catch (Exception e) {
			logger.info("DICOM Tag: " + tagNr + " not found in Dict");
			return "";
		}
	}
        
        /**
	 * returns the String representation of the given header field
	 * if it exists in the header
	 * @param tagNr
	 * @return
	 */
	public String getHeader(int tagNr) {
	    try {
	    	DicomElement dcmele = dicomObj.get(tagNr);
	    	return toElementString(dcmele);
	    } catch (Exception e) {
		logger.info("DICOM Tag: " + toTagString(tagNr) + " not found");
		return "";
	    }
	}


	private String toElementString(DicomElement dcmele) {
	    StringBuffer sb = new StringBuffer();
	    sb.append(toTagString(dcmele.tag()))
	    	.append(" [").append(dcmele.vr()).append("] ")
	    	.append(dict.nameOf(dcmele.tag())).append(": ")
	    	.append(getValue(dcmele));
	    return sb.toString();
	}
        
	/**
	 * returns a String representation of the value of the given header tag,
	 * not depending on its data type or if it is an array
	 * @param tag
	 * @return
	 */
	private Object getValue(DicomElement elem) {
	    StringBuffer sb = new StringBuffer();
	    try {
		String[] values = elem.getStrings(dicomObj.getSpecificCharacterSet(),false);
		sb.append(values[0]);
		for (int i = 1; i < values.length; i++) {
		    sb.append("/").append(values[i]);
		}
	    } catch (Exception e) {
		try {
		    sb.append(elem.getString(dicomObj.getSpecificCharacterSet(),false));
		} catch (Exception e2) {
		    return "";
		}
	    }
	    return sb.toString();
	}
/**
	 * returns the String representation of the given header field
	 * if it exists in the header
	 * @param tagNr
	 * @return
	 * @throws DicomHeaderParseException
	 */
	public String getHeader(String tagNr)  {
	    return getHeader(toTagInt(tagNr));
	}
        
        /**
	 * checks wether the header is empty or not
	 * @return
	 */
	public boolean isEmpty() {
	    if (dicomObj == null || dicomObj.size() == 0) {
			return true;
	    }
		return false;
	}

        /**
	 * Converts the string representation of a header number
	 * e.g. 0008,0010 to the corresponding integer as 0x00080010
	 * as used in the @see org.dcm4che2.data.Tag
	 * @param headerNr e.g. 0008,0010
	 * @return 0x00080010 as int
	 * @throws DicomHeaderParseException
	 */
	public static int toTagInt(String headerNr){
		return Integer.parseInt(headerNr.replaceAll(",", ""), 16);
	}

        /**
	 * converts the int representation of a header number
	 * e.g. 0x00080010 to the corresponding String 0008,0010
	 * @param headerNr e.g. 0x00080010 as int
	 * @return 0008,0010 as String
	 */
	public static String toTagString(int tagNr) {
            
            
            
	    return StringUtils.shortToHex(tagNr >> 16) +
		',' + StringUtils.shortToHex(tagNr);
	}


                /**
	 	 * Round  double after dot
	 	 * @param a : value convertor
	 	 * @param n number of decade 
	 	 * @return new value
	 	 */
	  public double floor(double a, int n){
	  		double p =Math.pow(10.0,n);
	  	return Math.floor((a*p)+0.5)/p;
	  	}

        
                /**
	  	 * Giving power
                 * Example:
                 *          setFactorPower(10,2)//10^2
	  	 * @param result3
	  	 * @param factor
	  	 * @return
	  	 * @return
	  	 */
	  	public static double setFactorPower(double result3, double factor){
	  	 	   return resultFactorDix= Math.pow(result3, factor);
  		 	}
	  	
                /**
	  	 * Giving  getFactorPower
	  	 */
	  	public static double getFactorPower(){
	  		return resultFactorDix;
	  	}

                public static int[] lattricePixelData(DicomObject dcmObj){
                    int[] data = dcmObj.get(Tag.PixelData).getInts(false);
                    return data;
                }

               public static int[] lattricePixelData2(File fileInput){
                    DicomObject dcmObj = readDicomObject(fileInput);
                    int[] data = dcmObj.get(Tag.PixelData).getInts(false);
                    return data;
                 }

               public byte[] lattricePixelDataBytes(DicomObject dcmObj){
                    byte[] data = dcmObj.getBytes(Tag.PixelData);
                    return data;
                }
               
                public byte[] lattricePixelDataBytes2(File fileInput){
                    DicomObject dcmObj = readDicomObject(fileInput);
                    byte[] data = dcmObj.getBytes(Tag.PixelData);
                    return data;
                }

                public int[] lattricePixelDataBytes3(DicomObject dcmObj){
                    byte[] data = dcmObj.getBytes(Tag.PixelData);
                    ByteUtils byteUtil = new ByteUtils();
                    return byteUtil.bytesBE2ints(data);
                    
                }

                public int [] lattricePixelDataBytes4(File fileInput){
                    DicomObject dcmObj = readDicomObject(fileInput);
                    byte[] data = dcmObj.getBytes(Tag.PixelData);
                    ByteUtils byteUtil = new ByteUtils();
                    return byteUtil.bytesBE2ints(data);

                }

        /**
         * Extraction PixelData 
         * @param raster of dicom
         * @return
         */
      private int[][] extractData(Raster raster) {
       // int w = image.getWidth();
       // int h = image.getHeight();
        int w = raster.getWidth();
        int h = raster.getHeight();

        System.out.printf("w = %d  h = %d%n", w, h);
        //WritableRaster raster = (WritableRaster) getMyImage();
        int[][] data = new int[h][w];
        for (int y = 0; y < h; y++) {
            for (int x = 0; x < w; x++) {
                data[y][x] =raster.getSample(x, y, 0);
            }
        }
        return data;
    }

       /**
         * Extraction PixelData
         * @param raster
         * @return
         */
  private int[] getPixelData(int[][] data2){
          int h = data2.length;
        int w = data2[0].length;
      int[] array = new int[h*w];
       for(int y = 0; y < h; y++) {
              for(int x = 0; x < w; x++) {
                   int index = y*w + x;
                   array[index] = data2[y][x];//ligne
            }
            }

return array;
}

/**
 * Return value table input 
 * @param object
 * @param PATIENT_ADDITIONAL_TAGS : Table int 
 *
 * example :
 *  public static final  int[] tag = {
    		0x00080020,
                0x00080022,
        };
 *
 *FileInputStream fis = new FileInputStream(fileInput);
 *DicomInputStream dis = new DicomInputStream(fis);
 *DicomObject obj = dis.readDicomObject();
 *String nounValue[] =getValue(obj,tag);
 *
 * @return
 */
private static String[] getValue(DicomObject object, int[]  PATIENT_ADDITIONAL_TAGS){
    String [] value = new String [PATIENT_ADDITIONAL_TAGS.length];
    int i =0;
    while (i<PATIENT_ADDITIONAL_TAGS.length){
	    for (int tag : PATIENT_ADDITIONAL_TAGS) {

                 value[i]=object.getString(tag);
                i++;
	    }

//System.out.print(value[0]+"\n");
//System.out.print(value[1]);
	}
     return value;
    }
    






  






// Method put

	/**
		 * Modify metadata dicom
		 * not vr= SQ
		 * @param file : input File
		 * @param tagChooser: choosing tag 
		 * @param aModify : "valueString"
		 * @param vr : vr of Tag choosing
		 * @param newString : new String
		 * exemple:
					try {
							Dicom.changementTag(chooser.getSelectedFile(), Tag.PatientName , "Dimitri", VR.PN, "piane"  );
						} catch (IOException e) {

							e.printStackTrace();
						}
		 * @throws IOException
		 */

		public static void changementTag(File file, int tagChooser, String aModify, VR vr, String newString ) throws IOException{

			DicomInputStream dis = new DicomInputStream(file);
			DicomObject dio = dis.readDicomObject();
			dis.close();

			boolean change = false;
		if(dio.getString(tagChooser).equals(aModify )){
			dio.putString(tagChooser, vr, newString);
			change = true;
		}

		if(change){
			FileOutputStream fos = new FileOutputStream( new File(file.getParent()+ "/"+file.getName()+ "(" + "modifier"+ ")"+".dcm"));
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			DicomOutputStream dos = new DicomOutputStream(bos);
			dos.writeDicomFile(dio);
			dos.close();
		      }
                }

/**
		 * Modify metadata dicom
		 * not vr= SQ
		 * @param file : input File
		 * @param tagChooser: choosing tag
		 * @param aModify : "valueString"
		 * @param vr : vr of Tag choosing
		 * @param newString : new String
                 * Example: 
		 * JChooser choix = new JChooser();
				   int retour = choix.showOpenDialog(parent);
		 		 *
		 		 * if(retour == JFileChooser.APPROVE_OPTION){
		 				fileInput = choix.getSelectedFile();
		  				JFileChooser saveDicom = new JFileChooser();
		  				saveDicom.setMultiSelectionEnabled(false);
	      				saveDicom.showSaveDialog(null);
	     		File fileOutput =saveDicom.getSelectedFile();

					} else return;
 * changementTag2(fileInput, int tagChooser, String aModify, VR vr, String newString,  fileOutput)
*/ 
		public static void changementTag2(File fileInput, int tagChooser, String aModify, VR vr, String newString, File fileOutput ) throws IOException{

			DicomInputStream dis = new DicomInputStream(fileInput);
			DicomObject dio = dis.readDicomObject();
			dis.close();

			boolean change = false;
		if(dio.getString(tagChooser).equals(aModify )){
			dio.putString(tagChooser, vr, newString);
			change = true;
		}

		if(change){
			FileOutputStream fos = new FileOutputStream(fileOutput +".dcm");
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			DicomOutputStream dos = new DicomOutputStream(bos);
			dos.writeDicomFile(dio);
			dos.close();
		      }
                }
                    /**
			 * Modify metadata dicom
                         * not Vr = SQ
			 * @param file
			 * @param tagChoix : 
			 * @param changer : 
			 * @param fileOuput : 
			 * @throws IOException
			 *  ex:
			 *    try {
					Dicom.changementTagGeneral(chooser.getSelectedFile(), Tag.PatientName, "p", "dcm.dcm");

                } catch (IOException e) {

					e.printStackTrace();
				}
			 *
			 *
			 *
			 */
			public static void changementTagGeneral(File fileInput, int tagChoix, String changer,String fileOutput   ) throws IOException{
						DicomInputStream dis = new DicomInputStream(fileInput);
                                                DicomObject dio = dis.readDicomObject();
				 		dio.putString(tagChoix,dio.vrOf(tagChoix) , changer);
						FileOutputStream fos = new FileOutputStream( new File(fileOutput+ "(" + "no original"+ ")"+".dcm"));
						BufferedOutputStream bos = new BufferedOutputStream(fos);
						DicomOutputStream dos = new DicomOutputStream(bos);
						dos.writeDicomFile(dio);
			}
/**
 * Modify Metadata
 * Example :
 *  * JChooser choix = new JChooser();
				   int retour = choix.showOpenDialog(parent);
		 		 *
		 		 * if(retour == JFileChooser.APPROVE_OPTION){
		 				fileInput = choix.getSelectedFile();
		  				JFileChooser saveDicom = new JFileChooser();
		  				saveDicom.setMultiSelectionEnabled(false);
	      				saveDicom.showSaveDialog(null);
	     		File fileOutput =saveDicom.getSelectedFile();

					} else return;
 * changementTagGeneral2(fileInput,Tag.Rows,"256",fileOutput);
 * @param fileInput
 * @param tagChooser
 * @param changer
 * @param fileOutput
 * @throws IOException
 */
                       public static void changementTagGeneral2(File fileInput, int tagChooser, String changer,File fileOutput   ) throws IOException{
                                                DicomInputStream dis = new DicomInputStream(fileInput);
                                                DicomObject dio = dis.readDicomObject();
				 		dio.putString(tagChooser,dio.vrOf(tagChooser) , changer);
                                                FileOutputStream fos = new FileOutputStream(new File(fileOutput+".dcm"));
                                                BufferedOutputStream bos = new BufferedOutputStream(fos);
                                                DicomOutputStream dos = new DicomOutputStream(bos);
                                                dos.writeDicomFile(dio); // Write Dicom
                                                 dos.close();
			}

/**
	 * Replaces the given dicom tag (if existing) with the given value.
	 * @param dObj
	 * @param tag
	 * @param newValue
	 */
	public static void replaceTag(DicomObject dObj, int tag, String newValue) {
	    if (tag != 0 && dObj.contains(tag)) {
		VR vr = dObj.vrOf(tag);
		try {
		    dObj.putString(tag, vr, newValue);
		} catch (Exception e) {
		    System.err.println("Error replacing Tag: " + tag + " with new value: " + newValue);
		}
	    }
	}
 /**
	 * adds/replaces the given dicom tag with the given value.
	 * @param dObj
	 * @param tag
	 * @param newValue
	 */
	public static void addTag(DicomObject dObj, int tag, String newValue) {
		VR vr = dObj.vrOf(tag);
		try {
		    dObj.putString(tag, vr, newValue);
		} catch (Exception e) {
		    System.err.println("Error adding Tag: " + tag + " with value: " + newValue);
		}
	}


/**
 * Putting tag item VR=SQ
 * 
 *  * Example :
public class test {
public static void main(String[] args){
         File fileInput = null, fileOutput= null;
	 JFileChooser choix = new JFileChooser();

	int retour = choix.showOpenDialog(null);

	if(retour == JFileChooser.APPROVE_OPTION){
        fileInput = choix.getSelectedFile();
	JFileChooser saveDicom = new JFileChooser();
        saveDicom.setMultiSelectionEnabled(false);
	saveDicom.showSaveDialog(null);
	fileOutput =saveDicom.getSelectedFile();

        }
displayTag display = new displayTag();//Building
        try {
            display.TagDicomItem(fileInput, 0x00291140,0x00291042,  org.dcm4che2.data.VR.LO, "DIMITRI",0x00400275,0x00401001,org.dcm4che2.data.VR.SH,"MOUSTACHE", fileOutput);
        } catch (IOException ex) {
            Logger.getLogger(test.class.getName()).log(Level.SEVERE, null, ex);
        }

 * Using vr=SQ
 * @param file : input file
 * @param TagItem : Tag is egal VR =SQ
 * @param Tag :   value(tag) --> TAG Item
 * @param VR : Value Representation Tag
 * @param newValue : modify value Tag
 * @param TagItem2 : Tag is egal VR=SQ (second  value)
 * @param Tag2 : value(tag2) --> TAG Item2
 * @param VR = Value Representation Tag
 * @param newValue2 : modify value Tag2
 * @param fileOutput : output file 
 * @throws IOException
 */
public void TagDicomItem(File file, int TagItem, int Tag, org.dcm4che2.data.VR vr, String newValue,int TagItem2, int Tag2, org.dcm4che2.data.VR vr2, String newValue2, File fileOutput) throws IOException{
	  		DicomInputStream dis = new DicomInputStream(file);
	 		
                        object = dis.readDicomObject();
	 		 
	 		 Iterator<DicomElement> iter = object.iterator();

	 		 while(iter.hasNext() ){
	 	    	   DicomElement element=  iter.next();
                             int tag = element.tag(); 
                      String tagVR =  ((DicomObject) object).vrOf(tag).toString(); //retourne la valeur attribuer avec sp�cification
                           if (tagVR.equals("SQ") | element.hasDicomObjects()){
                                    element.addDicomObject(element.getDicomObject());//New object dicom 
	 		    		   continue;
	 		    	   }
	 		       }
                         
                     DicomObject object2  = getObjectItem(object, TagItem);
                              object2.putString(Tag,vr , newValue);//object2.vrOf(TAG)
                     DicomObject object3  = getObjectItem(object, TagItem2);//Reading item(VR= SQ) value
                             object3.putString(Tag2, vr2, newValue2);//New value 2
                       
                         FileOutputStream fos = new FileOutputStream(fileOutput);
                         BufferedOutputStream bos = new BufferedOutputStream(fos);
                         DicomOutputStream dos = new DicomOutputStream(bos);
                         dos.writeDicomFile(object);
	 		 }


public void nget(Association as, int pcid, DicomObject rq, DicomObject data) throws DicomServiceException, IOException
{
System.out.println("========== INCOMING MESSAGE ==============");
System.out.println(rq.toString());
System.out.println("========== END OF INCOMING MESSAGE ==============");

DicomObject rsp = CommandUtils.mkRSP(rq, CommandUtils.SUCCESS);
rsp.putInt(Tag.DataSetType, VR.US, 0);
DicomObject dataset = new BasicDicomObject();
dataset.putString(Tag.PrinterStatus, VR.CS, "NORMAL");
dataset.putString(Tag.PrinterStatusInfo, VR.CS, "NORMAL");
as.writeDimseRSP(pcid, rsp, dataset);


System.out.println("========== OUTGOING MESSAGE ==============");
System.out.println(rsp.toString());
System.out.println("========== END OF OUTGOING MESSAGE ==============");
as.writeDimseRSP(pcid, rsp);
}

/**
	 * Writing the dicom object to a file
	 * @param dObj the object to write
	 * @param f the file to write to
	 */
	public static void writeDicomFile(DicomObject dObj, File f) {
	    FileOutputStream fos;
	    try {
	        fos = new FileOutputStream(f);
	    }
	    catch (FileNotFoundException e) {
	        e.printStackTrace();
	        return;
	    }
	    BufferedOutputStream bos = new BufferedOutputStream(fos);
	    DicomOutputStream dos = new DicomOutputStream(bos);
	    try {
	        dos.writeDicomFile(dObj);
	    }
	    catch (IOException e) {
	        e.printStackTrace();
	        return;
	    }
	    finally {
	        try {
	            dos.close();
	        }
	        catch (IOException ignore) {
	        }
	    }
	}



//others methods
public static String getPixelSpacing(DicomObject dcmObj) {
    DicomElement pffgs = dcmObj.get(Tag.PerFrameFunctionalGroupsSequence);
if (pffgs != null && pffgs.hasItems()) {
    DicomObject subObj = pffgs.getDicomObject(0);
    DicomElement pms = subObj.get(Tag.PixelMeasuresSequence);
if (pms != null && pms.hasItems()) {
    DicomObject subObj1 = pms.getDicomObject(0);
return subObj1.getString(Tag.PixelSpacing);
}
}
return null;
}



} // end function	